#<profile4xi profile = "31"/>
#<program4xi program = "generate2gun4uri.py">
#<abstract4xi abstract = "generates modules which activate processes with target functions to check local hyperlinks in HTML files"/>
#<refer4xi reference = "automate2ref4uri.py"/>
#<note4xi note = "generate2gun4uri.py has been used as model"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'generate2gun4uri' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from print4xi import print4xi
from print4xi import Print4Xi 
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global count2skipped
global count2found
global count2total
global kb2process                            # knowledgebase for processing
global kb2change                             # knowledgebase for changing
global kb2keep                               # knowledgebase for keeping
global kb2select                             # knowledgebase for selecting
global path2temp4source  
global path2read4xi                          # path for input source programs
global path2write4xi                         # path for output source programs
global PickleKB4Xi
global profile2fetch                         # extension for files
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
count2skipped = 0
count2found = 0
count2total = 0 
kb2process = {}                            

                                          
# -------------------------------------------------------------------------------------------------
# DEFINE SEARCH PATTERNS - MAX 8 PER PATTERN IN ONE LINE
# -------------------------------------------------------------------------------------------------
small2replace = "dragon"
capital2replace = "DRAGON"
kb2search = {}                               
kb2search[1] = {}                            # first search pattern
kb2search[1] [1]      = small2replace             
kb2search[1] [2]      = small2replace 
kb2search[1] [3]      = small2replace  
kb2search[1] [4]      = small2replace 
kb2search[1] [5]      = small2replace 
kb2search[1] [6]      = small2replace 
kb2search[1] [7]      = small2replace 
kb2search[1] [8]      = small2replace 
 
kb2search[2] = {}                            # second search pattern
kb2search[2] [1]      = capital2replace             
kb2search[2] [2]      = capital2replace 
kb2search[2] [3]      = capital2replace 
kb2search[2] [4]      = capital2replace 
kb2search[2] [5]      = capital2replace 
kb2search[2] [6]      = capital2replace 
kb2search[2] [7]      = capital2replace 
kb2search[2] [8]      = capital2replace 


# ------------------------------------------------------------------------------------------------------------------
# KEEP
# ------------------------------------------------------------------------------------------------------------------
kb2keep = {} 
kb2keep[1] = "dragoniz"
       
    
# ------------------------------------------------------------------------------------------------------------------
# PATHS
# ------------------------------------------------------------------------------------------------------------------
path2read4xi  = VersionKB4Xi['folder2read4dragon']  # defines folder to be read
path2write4xi = VersionKB4Xi['folder2write4dragon'] # defines folder to save programs

# path2read4xi  = VersionKB4Xi['input2dragonize4scope']  # defines folder to be read
# path2write4xi = VersionKB4Xi['output2dragonize4scope'] # defines folder to save programs


# ------------------------------------------------------------------------------------------------------------------
# PICKLING
# ------------------------------------------------------------------------------------------------------------------
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = '.py'                        # Python programs to be fetched only
                                             # Ref: '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C

#"
#/>


       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "generate2gun4uri" usage = "
#   dragonizes defined programs to become master modules for OpenCL devices apu ... zpu
#"> 
# -------------------------------------------------------------------------------------------------
def generate2gun4uri(program2explore, target2process = None, direction2process = None):
    global count2skipped
    global count2found
    global count2total
    global kb2process                          # knowledgebase for dragonizing
    global kb2change                             # knowledgebase for changing
    global kb2keep                               # knowledgebase for keeping       
    global kb2search                             # knowledgebase for searching
    global path2read4xi                          # path for input source programs
    global path2write4xi                         # path for output source programs
    global profile2fetch                         # extension for files

    class2print  = "generate2gun4uri"
    method2print = "generate2gun4uri" 
 
    message2print = "{(Step 0A/8) got" + "; program2explore-got-by-generate2gun4uri: " + str(program2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # E://temp//dragonize//in//gun2dragon4uri.py

      
    if target2process is None:
        target2process = "gun"
        message2print = "{(Step 0B/8) set" + "; target2process-set-by-generate2gun4uri to: " + str(target2process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #     
    else:
        message2print = "{(Step 0C/8) got" + "; target2process-got-by-generate2gun4uri to: " + str(target2process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
    if direction2process is None:
        direction2process = "eleven"
        message2print = "{(Step 0D/8) set" + "; direction2process-set-by-generate2gun4uri to: " + str(direction2process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    else:
        message2print = "{(Step 0E/8) got" + "; direction2process-got-by-generate2gun4uri to: " + str(direction2process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
    # -------------------------------------------------------------------------------------------------
    # DEFINE CHANGE PATTERNS - MAX 8 PER PATTERN IN ONE LINE
    # -------------------------------------------------------------------------------------------------
    kb2change = {}                               # change patterns
    kb2change[1] = {}                            # first change pattern, max 8 in each line 
    kb2change[1] [1]      = direction2process         
    kb2change[1] [2]      = direction2process 
    kb2change[1] [3]      = direction2process 
    kb2change[1] [4]      = direction2process 
    kb2change[1] [5]      = direction2process 
    kb2change[1] [6]      = direction2process 
    kb2change[1] [7]      = direction2process 
    kb2change[1] [8]      = direction2process 

    capital2direction = direction2process.upper()                                        # ELEVEN   
            
    kb2change[2] = {}                            # second change pattern, max 8 in each line 
    kb2change[2] [1]      = capital2direction       
    kb2change[2] [2]      = capital2direction
    kb2change[2] [3]      = capital2direction
    kb2change[2] [4]      = capital2direction
    kb2change[2] [5]      = capital2direction
    kb2change[2] [6]      = capital2direction
    kb2change[2] [7]      = capital2direction
    kb2change[2] [8]      = capital2direction        
            
       
                 
  
    key2process = target2process + "2dragon4uri.py"                                   # gun2dragon4uri.py                                                         
    kb2process[key2process]  = target2process + "2" + direction2process + "4uri.py"   # kb2process[gun2dragon4uri.py]  = [gun] + [2] + [eleven] + [4uri.py] = gun2eleven4uri.py 
    
             
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program=os.path.splitext(program2explore)
    
    if name2program[1] == profile2fetch:          
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF GENERATE2GUN4URI - PYTHON PROGRAM
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore-analyzing-by-generate2gun4uri: " + str(program2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # E://temp//dragonize//in//gun2dragon4uri.py
        
        path2input = name2program[0] + profile2fetch 
        message2print = "{(Step 1B/33) set" + "; path2input-set-by-generate2gun4uri to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # E://temp//dragonize//in//gun2dragon4uri.py
         
        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF GENERATE2GUN4URI - CHECKING WHETHER INPUT IS PROGRAM FILE
        # -----------------------------------------------------------------------------------------
        keys2process = kb2process.keys()                                                                        
        ack2match = False
        for key2process in keys2process:                                                                        
            string2search = key2process                                                                           
            index2search=str.find(path2input,string2search)                                                         
            if index2search == -1:                                         
                pass                                                                                                
            else:
                program2write = kb2process[path2input[index2search:]]                                             
                path2write4program = path2write4xi + program2write                                                  
                ack2match = True
                    
        if ack2match is True:
            # -----------------------------------------------------------------------------------------
            # (Step 3/33) OF GENERATE2GUN4URI - PROGRAM TO BE DRAGONIZED
            # -----------------------------------------------------------------------------------------        
            message2print = "{(Step 3A/33) decided" + "; program-to-read-decided-by-generate2gun4uri: " + str(path2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
            # E://temp//dragonize//in//gun2dragon4uri.py
            
            message2print = "{(Step 3B/33) decided" + "; program-to-write-decided-by-generate2gun4uri: " + str(path2write4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            # E://temp//dragonize//out//gun2eleven4uri.py
            
                          
            count2found = count2found + 1
            count2total = count2total + 1
            # -----------------------------------------------------------------------------------------
            # (Step 4/33) OF GENERATE2GUN4URI - OPEN INPUT
            # -----------------------------------------------------------------------------------------
            file2input = open(path2input,'r')
            message2print = "{(Step 4A/33) opened" + "; file2input-opened-by-generate2gun4uri: " + str(file2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # <_io.TextIOWrapper name='E://temp//dragonize//in//gun2dragon4uri.py' mode='r' encoding='cp1252'>
            
            # -----------------------------------------------------------------------------------------
            # (Step 5/33) OF GENERATE2GUN4URI - OPEN OUTPUT
            # -----------------------------------------------------------------------------------------
            file2output = open(path2write4program,'w')                                                              # L://temp//py//dragon2image4xi.py
            message2print = "{(Step 5A/33) opened" + "; file2output-opened-by-generate2gun4uri: " + str(file2output) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)              
            # <_io.TextIOWrapper name='E://temp//dragonize//out//gun2eleven4uri.py' mode='w' encoding='cp1252'>
            
            while 1:
                # -------------------------------------------------------------------------------------
                # (Step 7/33) OF GENERATE2GUN4URI - PROCESS SOURCE FILE
                # -------------------------------------------------------------------------------------             
                line2process = file2input.readline()                                                                # import os 
                message2print = "{(Step 7A/33) using" + "; line2process-using-by-generate2gun4uri: " + str(line2process)  + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)
                # #<profile4xi profile = "11" /> 
                
                ack2match = False
                
                if not line2process:
                    # ---------------------------------------------------------------------------------
                    # (Step 30/33) OF GENERATE2GUN4URI - ALL LINES READ, FINISH
                    # ---------------------------------------------------------------------------------             
                    break                                               
                else:
                    # ---------------------------------------------------------------------------------
                    # (Step 8/33) OF GENERATE2GUN4URI - PROCESS LINE
                    # ---------------------------------------------------------------------------------
                    ack2process = False                                 # default no dragonizing
                    ack2except = False                                    # default no exception
                    
                    message2print = "{(Step 8A/33) using" + "; line2process-using-by-generate2gun4uri: " + str(line2process)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #  
                    
                    
                    line2write = line2process                                                                      
                    message2print = "{(Step 8B/33) set" + "; line2write-set-by-generate2gun4uri to: " + str(line2write)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # 
                    keys2search = kb2search.keys()                               #                                                                                                                     

                    for key2search in keys2search:                               #  
                        kb2pattern = kb2search[key2search]                       # 
                        keys2pattern = kb2pattern.keys()                         
                        for key2pattern in keys2pattern:                         # 
                                                    
                            # ---------------------------------------------------------------------------------------
                            # (Step 9/33) OF GENERATE2GUN4URI - GO THROUGH ALL STRINGS POSSIBLE NEEDING DRAGONIZING
                            # ---------------------------------------------------------------------------------------
                        
                        
                            # -------------------------------------------------------------------------------------
                            # (Step 10/33) OF GENERATE2GUN4URI - LOOK FOR SPECIAL STRINGS  
                            # -------------------------------------------------------------------------------------                            
                            string2look = kb2search[key2search] [key2pattern]                                                              
                            message2print = "{(Step 10A/33) using" + "; string2look-using-by-generate2gun4uri: " + str(string2look)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                                 
                            index2look = str.find(line2write,string2look)                                         
                            message2print = "{(Step 10B/33) set" + "; index2look-set-by-generate2gun4uri to: " + str(index2look)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            # 
                                
                            if index2look == -1:
                                # -----------------------------------------------------------------------------------
                                # (Step 11/33) OF GENERATE2GUN4URI - THIS DEVICE SPECIFIC STRING NOT FOUND IN LINE 
                                # -----------------------------------------------------------------------------------                                         
                                message2print = "{(Step 11A/33) checked" + "; index2look-checked-by-generate2gun4uri: " + str(index2look) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                            else:
                                # --------------------------------------------------------------------------------------------------
                                # (Step 12/33) OF GENERATE2GUN4URI - DEVICE SPECIFIC FOUND - CHECK WHETHER IT IS FOR OTHER MODULES 
                                # --------------------------------------------------------------------------------------------------                         
                                if ack2except is False:
                                    keys2keep = kb2keep.keys()
                                                                                              
                                    for key2keep in keys2keep:                                                              # 
                                        string2keep = kb2keep[key2keep]                                                     # 
                                        # message2print = "{(Step 12A/33) using" + "; string2keep-using-by-generate2gun4uri: " + str(string2keep)  + "; time: " + time4xi() + "}"
                                        # print4xi(class2print, method2print, message2print)
                                        # 
                                
                                        index2keep=str.find(line2write,string2keep)
                                        if index2keep == -1:
                                            # -----------------------------------------------------------------------
                                            # (Step 14/33) OF GENERATE2GUN4URI - NO EXCEPTION TO KEEP - DRAGONIZED 
                                            # -----------------------------------------------------------------------                                
                                            if ack2except is False:
                                                ack2process = True
                                                message2print = "{(Step 14B/33) set" + "; ack2process-set-by-generate2gun4uri to: " + str(ack2process) + "; time: " + time4xi() + "}"
                                                print4xi(class2print, method2print, message2print) 
                                                #                                
                                        else:
                                            # ------------------------------------------------------------------
                                            # (Step 15/33) OF GENERATE2GUN4URI - EXCEPTION - NOT DRAGONIZED  
                                            # ------------------------------------------------------------------                                   
                                            ack2except = True 
                                            message2print = "{(Step 15A/33) set" + "; ack2except-set-by-generate2gun4uri to: " + str(ack2except) + "; time: " + time4xi() + "}"
                                            print4xi(class2print, method2print, message2print) 
                                            #
                                        
                                            ack2process = False
                                                                              
                                            # --------------------------------------------------------------------------
                                            # EOF CHECKING WHETHER LINE IS REFERRING TO OTHER MODULES
                                            # --------------------------------------------------------------------------
                                else:
                                    pass # only once
                         

                            if ack2process is True:
                                # -----------------------------------------------------------------
                                # (Step 17/33) OF GENERATE2GUN4URI - DRAGONIZE IT!
                                # -----------------------------------------------------------------                                    
                                message2print = "{(Step 17A/33) using" + "; index2look-using-by-generate2gun4uri: " + str(index2look)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                #                                     
                                line2write = line2write[0:index2look:] + kb2change[key2search] [key2pattern] + line2write[index2look+len(string2look):] 
                                                                                                                        
                                message2print = "{(Step 17B/33) set" + "; line2write-set-by-generate2gun4uri to: " + str(line2write)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # 
                                ack2process = False
                                 
                            else:
                                # ----------------------------------------------------------------------------
                                # (Step 18/33) OF GENERATE2GUN4URI - NO NEED TO DRAGONIZE IN THIS ROUND
                                # ----------------------------------------------------------------------------                         
                                message2print = "{(Step 18A/33) skipped" + "; line2write-skipped-by-generate2gun4uri: " + str(line2write)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # #<profile4xi profile = "11" /> 
                                
                            # ---------------------------------------------------------------------------------
                            # EOF CHECKING POSSIBLE TOKENS FOR DRAGONIZING THE ORIGINAL OR UPDATED LINE
                            # ---------------------------------------------------------------------------------
                        
                                               
                    # ---------------------------------------------------------------------------------
                    # (Step 29/33) OF GENERATE2GUN4URI - WRITE LINE
                    # ---------------------------------------------------------------------------------
                    message2print = "{(Step 29A/33) writing" + "; line2write-writing-by-generate2gun4uri: " + str(line2write)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                  
                    #
                    
                    file2output.write(line2write)
                    

            
            # -----------------------------------------------------------------------------------------
            # (Step 31/33) OF GENERATE2GUN4URI - CLOSE INPUT
            # -----------------------------------------------------------------------------------------            
            file2input.close()
            message2print = "{(Step 31A/33) closed" + "; file2input-closed-by-generate2gun4uri: " + str(file2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            # <_io.TextIOWrapper name='E://temp//dragonize//in//gun2dragon4uri.py' mode='r' encoding='cp1252'>
            
                        
            # -----------------------------------------------------------------------------------------
            # (Step 32/33) OF GENERATE2GUN4URI - CLOSE OUTPUT
            # -----------------------------------------------------------------------------------------            
            file2output.close()
            message2print = "{(Step 31B/33) closed" + "; file2output-closed-by-generate2gun4uri: " + str(file2output) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <_io.TextIOWrapper name='E://temp//dragonize//out//gun2eleven4uri.py' mode='w' encoding='cp1252'>
            
        else:
            message2print = "{(Step 1E/33) skipped" + "; path2input-skipped-by-generate2gun4uri: " + str(path2input)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
            # 
            count2skipped = count2skipped + 1
            count2total = count2total + 1

    else:
        message2print = "{(Step 1F/33) skipped" + "; name2program-skipped-by-generate2gun4uri: " + str(name2program)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # 
        
        extension2skip = name2program[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-generate2gun4uri: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc
        count2skipped = count2skipped + 1
        count2total = count2total + 1
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global count2skipped
    global count2found
    global count2total
    
    global path2read4xi
    global path2write4xi
    global profile2fetch


       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    count2skipped = 0
    count2found = 0
    count2total  = 0   


    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print("(Step 2A/33) OF MAIN GENERATE2GUN4URI - PATH2READ4XI: ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # E://temp//dragonize//in//  WITH PROFILE:  .py  STARTED  18:55:48 01/18/15 FLE Standard Time 
    
    path2temp4source = VersionKB4Xi['folder2read4dragon']
    print ('(Step 2B/33) OF MAIN GENERATE2GUN4URI - PATH2WRITE4XI: ', path2write4xi)
    # E://temp//dragonize//out//
   
 
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print ("(Step 3A/33) OF MAIN GENERATE2GUN4URI - Directory: " + file2walk + '\n') 
        if os.path.isfile(file2walk):
            print ("(Step 3B/33) OF MAIN GENERATE2GUN4URI - Input file: " + file2walk + '\n')
            # E://temp//dragonize//in//gun2dragon4uri.py
                        
            #1) test without parameters:
            #generate2gun4uri(file2walk)
            
            #2) test with two parameters:
            # target2process = "gun"                        
            # direction2process = "twelve" / "eleven" / "nine" / "ten"
            generate2gun4uri(file2walk, direction2process = "thirteen")
            
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 4A/33) OF MAIN GENERATE2GUN4URI - PATH2READ4XI: ", path2read4xi, " WITH PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
    # E://temp//dragonize//in//
           
    # -------------------------------------------------------------------------------------------
    # STATISTICS
    # ------------------------------------------------------------------------------------------- 
    print ('(Step 5A/33) OF MAIN GENERATE2GUN4URI - FOUND: ', count2found)
    # 1
    print ('(Step 5B/33) OF MAIN GENERATE2GUN4URI - SKIPPED: ', count2skipped)
    # 0
    print ('(Step 5C/33) OF MAIN GENERATE2GUN4URI - TOTAL: ', count2total)
    # 1
    test2total = count2found + count2skipped
    if test2total == count2total:
        pass
    else:
        print ('(Step 5Z/33) OF MAIN GENERATE2GUN4URI *** FAILED: FOUND + SKIPPED: ', test2total, " .NE. TOTAL: ", count2total, " ***")

#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# generate2gun4uri.txt
# ace-generate2gun4uri.xml
# reason-generate2gun4uri.xml
# sense-generate2gun4uri.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of generate2gun4uri.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

